Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/ROUND.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/ROUND.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/ROUND.json	(revision 44089)
@@ -3,8 +3,8 @@
     "group": "Numeric",
     "template": "ROUND({{number}})",
     "args": [
-        "value whose arc tangent is to be returned"
+        "number - The number to be rounded"
     ],
-    "description": "Returns the arc cosine of a value; the returned angle is in the range 0.0 through pi.",
+    "description": "Rounds a number to a specified number of decimal places.",
     "returnType": "Double"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/SQRT.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/SQRT.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/SQRT.json	(revision 44089)
@@ -3,8 +3,8 @@
     "group": "Numeric",
     "template": "SQRT({{number}})",
     "args": [
-        "value whose arc tangent is to be returned"
+        "number - A number to calculate the square root of. Must be greater than 0"
     ],
-    "description": "Returns the arc cosine of a value; the returned angle is in the range 0.0 through pi.",
+    "description": "Return the square root of a number.",
     "returnType": "Double"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LENGHT.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LENGHT.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LENGHT.json	(revision 44089)
@@ -5,10 +5,7 @@
     "args": [
         "string - string to return the length for"
     ],
-    "description": "Returns the number of characters in a string. This method returns a long. For BLOB, CLOB, BYTES and JAVA_OBJECT, the precision is used.
-
-Example:
-
-LENGTH(NAME)",
+    "description": ["Returns the number of characters in a string. This method returns a long. For BLOB, CLOB, BYTES and JAVA_OBJECT, the precision is used.",
+    "Example: LENGTH(NAME)"],
     "returnType": "Integer"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/RADIANS.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/RADIANS.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/RADIANS.json	(revision 44089)
@@ -1,10 +1,10 @@
 {
     "name": "RADIANS",
     "group": "Numeric",
-    "template": "RADIANS({{a}})",
+    "template": "RADIANS({{number}})",
     "args": [
-        "value whose arc tangent is to be returned"
+        "number - A number in degrees"
     ],
-    "description": "Returns the arc cosine of a value; the returned angle is in the range 0.0 through pi.",
+    "description": "Converts a degree value into radians.",
     "returnType": "Double"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LOG.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LOG.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LOG.json	(revision 44089)
@@ -1,10 +1,10 @@
 {
     "name": "LOG",
     "group": "Numeric",
-    "template": "LOG({{a}})",
+    "template": "LOG({{number}})",
     "args": [
-        "value whose arc tangent is to be returned"
+        "number - A number. Must be greater than 0"
     ],
-    "description": "Returns the arc cosine of a value; the returned angle is in the range 0.0 through pi.",
+    "description": "Returns the natural logarithm of a specified number, or the logarithm of the number to the specified base.",
     "returnType": "Double"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/RAND.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/RAND.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/RAND.json	(revision 44089)
@@ -1,10 +1,12 @@
 {
     "name": "RAND",
     "group": "Numeric",
-    "template": "RAND({{number}})",
+    "template": "RAND({{seed}})",
     "args": [
-        "value whose arc tangent is to be returned"
+        "seed - Optional. ",
+        "* If seed is specified, it returns a repeatable sequence of random numbers.",
+        "* If no seed is specified, it returns a completely random number"
     ],
-    "description": "Returns the arc cosine of a value; the returned angle is in the range 0.0 through pi.",
+    "description": "Returns a random number between 0 (inclusive) and 1 (exclusive).",
     "returnType": "Double"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/TANH.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/TANH.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/TANH.json	(revision 44089)
@@ -5,6 +5,6 @@
     "args": [
         "a - an angle, in radians."
     ],
-    "description": "Returns the arc cosine of a value; the returned angle is in the range 0.0 through pi.",
+    "description": "Return the tangent of a number.",
     "returnType": "Double"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/EXP.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/EXP.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/EXP.json	(revision 44089)
@@ -1,10 +1,11 @@
 {
     "name": "EXP",
     "group": "Numeric",
-    "template": "EXP({{a}})",
+    "template": "EXP({{number}})",
     "args": [
-        "value whose arc tangent is to be returned"
+        "number - The power number"
     ],
-    "description": "Returns the arc cosine of a value; the returned angle is in the range 0.0 through pi.",
+    "description": ["returns e raised to the power of the specified number.",
+    "The constant e (2.718281...), is the base of natural logarithms."],
     "returnType": "Double"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/COSH.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/COSH.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/COSH.json	(revision 44089)
@@ -3,7 +3,7 @@
     "group": "Numeric",
     "template": "COSH({{a}})",
     "args": [
-        "a - The number whose hyperbolic cosine is to be returned."
+        "a - an angle, in radians"
     ],
     "description": [
       "Returns the hyperbolic cosine of a double value. The hyperbolic cosine of x is defined to be (ex + e-x)/2 where e is Euler's number.",
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/SIGN.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/SIGN.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/SIGN.json	(revision 44089)
@@ -1,10 +1,14 @@
 {
     "name": "SIGN",
     "group": "Numeric",
-    "template": "SIGN({{a}})",
+    "template": "SIGN({{number}})",
     "args": [
-        "value whose arc tangent is to be returned"
+        "number - The number to return the sign for"
     ],
-    "description": "Returns the arc cosine of a value; the returned angle is in the range 0.0 through pi.",
+    "description": ["Returns the sign of a number.",
+    "This function will return one of the following:",
+    "If number > 0, it returns 1",
+    "If number = 0, it returns 0",
+    "If number < 0, it returns -1"],
     "returnType": "Double"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/SINH.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/SINH.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/SINH.json	(revision 44089)
@@ -5,6 +5,6 @@
     "args": [
         "a - an angle, in radians."
     ],
-    "description": "Returns the arc cosine of a value; the returned angle is in the range 0.0 through pi.",
+    "description": "Return the hyperbolic sine of a number.",
     "returnType": "Double"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LOCATE.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LOCATE.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LOCATE.json	(revision 44089)
@@ -7,10 +7,8 @@
         "string - The string that will be searched",
         "start - The starting position for the search. Position 1 is default"
     ],
-    "description": "Returns the location of a search string in a string. If a start position is used, the characters before it are ignored. If position is negative, the rightmost location is returned. 0 is returned if the search string is not found.
-
-Example:
-
-LOCATE('.', NAME)",
+    "description": ["Returns the location of a search string in a string. If a start position is used, the characters before it are ignored.",
+      " If position is negative, the rightmost location is returned. 0 is returned if the search string is not found.",
+      "Example: LOCATE('.', NAME)"],
     "returnType": "Double"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/DEGREES.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/DEGREES.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/DEGREES.json	(revision 44089)
@@ -3,8 +3,8 @@
     "group": "Numeric",
     "template": "DEGREES({{a}})",
     "args": [
-        "value whose arc tangent is to be returned"
+        "a - value in radians"
     ],
-    "description": "Returns the arc cosine of a value; the returned angle is in the range 0.0 through pi.",
+    "description": "Converts a value in radians to degrees.",
     "returnType": "Double"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LPAD.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LPAD.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LPAD.json	(revision 44089)
@@ -7,6 +7,9 @@
         "len - The length of the string after it has been left-padded",
         "padstr - The string to left-pad to string"
     ],
-    "description": "Left pad the string to the specified length. If the length is shorter than the string, it will be truncated at the end. If the padding string is not set, spaces will be used. Example: LPAD(AMOUNT, 10, '*') ",
+    "description": ["Left pad the string to the specified length.",
+      "If the length is shorter than the string, it will be truncated at the end.",
+      "If the padding string is not set, spaces will be used.",
+      "Example: LPAD(AMOUNT, 10, '*') "],
     "returnType": "String"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/FLOOR.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/FLOOR.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/FLOOR.json	(revision 44089)
@@ -1,10 +1,10 @@
 {
     "name": "FLOOR",
     "group": "Numeric",
-    "template": "FLOOR({{a}})",
+    "template": "FLOOR({{number}})",
     "args": [
-        "value whose arc tangent is to be returned"
+        "number - A numeric value"
     ],
-    "description": "Returns the arc cosine of a value; the returned angle is in the range 0.0 through pi.",
+    "description": "Returns the largest integer value that is smaller than or equal to a number.",
     "returnType": "Double"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LOG10.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LOG10.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/LOG10.json	(revision 44089)
@@ -1,10 +1,10 @@
 {
     "name": "LOG10",
     "group": "Numeric",
-    "template": "LOG10({{a}})",
+    "template": "LOG10({{number}})",
     "args": [
-        "value whose arc tangent is to be returned"
+        "number - A number greater than 0"
     ],
-    "description": "Returns the arc cosine of a value; the returned angle is in the range 0.0 through pi.",
+    "description": "Returns the natural logarithm of a number to base-10.",
     "returnType": "Double"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/ATAN.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/ATAN.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/ATAN.json	(revision 44089)
@@ -5,6 +5,10 @@
     "args": [
         "a - an angle, in radians."
     ],
-    "description": ["Returns the arc tangent of a number."],
+    "description": ["Returns the arc tangent of a value; the returned angle is in the range -pi/2 through pi/2. Special cases:",
+            "- If the argument is NaN, then the result is NaN.",
+            "- If the argument is zero, then the result is a zero with the same sign as the argument.",
+            "The computed result must be within 1 ulp of the exact result. Results must be semi-monotonic.",
+            "ATAN({{a}})"],
     "returnType": "Double"
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/ACOS.json
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/ACOS.json	(revision 44088)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/resources/org/gvsig/expressionevaluator/functions/en/ACOS.json	(revision 44089)
@@ -3,8 +3,9 @@
     "group": "Numeric",
     "template": "ACOS({{a}})",
     "args": [
-        "value whose arc tangent is to be returned"
+        "a - an angle, in radians"
     ],
-    "description": "Returns the arc cosine of a value; the returned angle is in the range 0.0 through pi.",
+    "description": ["The ACOS() function returns the arc cosine of a number.",
+      "The specified number must be between -1 to 1, otherwise this function returns NULL."],
     "returnType": "Double"
 }