Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureStore.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureStore.java	(revision 44110)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureStore.java	(revision 44111)
@@ -2924,4 +2924,14 @@
         FeatureReference featureReference = new DefaultFeatureReference(this, code);
         return featureReference;
     }
+
+    @Override
+    public long getPendingChangesCount() {
+        if( this.featureManager==null ) {
+            return 0;
+        }
+        return this.featureManager.getPendingChangesCount();
+    }
+    
+    
 }
\ No newline at end of file
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/editing/memory/FeatureManager.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/editing/memory/FeatureManager.java	(revision 44110)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/editing/memory/FeatureManager.java	(revision 44111)
@@ -206,6 +206,20 @@
 
     }
 
+    public long getPendingChangesCount() {
+        long count = 0;
+        if( this.added!=null ) {
+            count += this.added.size();
+        }
+        if( this.deleted!=null ) {
+            count += this.deleted.size();
+        }
+        if( this.modifiedFromOriginal!=null ) {
+            count += this.modifiedFromOriginal.size();
+        }
+        return count;
+    }
+
     private class DeletedIterator implements Iterator {
 
         private Boolean hasnext = null;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/test/java/org/gvsig/fmap/dal/feature/DummyFetureStore.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/test/java/org/gvsig/fmap/dal/feature/DummyFetureStore.java	(revision 44110)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/test/java/org/gvsig/fmap/dal/feature/DummyFetureStore.java	(revision 44111)
@@ -738,4 +738,9 @@
         return null;
     }
 
+    @Override
+    public long getPendingChangesCount() {
+        return 0;
+    }
+
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/feature/FeatureStore.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/feature/FeatureStore.java	(revision 44110)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/feature/FeatureStore.java	(revision 44111)
@@ -914,7 +914,19 @@
      * @param index
      * @return
      */
-    SpatialIndex wrapSpatialIndex(SpatialIndex index);
+    public SpatialIndex wrapSpatialIndex(SpatialIndex index);
     
     public FeatureReference getFeatureReference(String code);
+
+    /**
+     * Devuelbe el numero de operaciones pendientes de guardar en una sesion
+     * de edicion. Es un valor orientativo.
+     * Las operaciones pendientes son la suma de operaciones de borrado, insercion
+     * o modificacion de las features en una sesion de edicion.
+     * 
+     * Retorna 0 si no esta en edicion.
+     * 
+     * @return numero de operaciones pendientes. 
+     */
+    public long getPendingChangesCount();
 }