Index: FeatureTypeAttributePanelView.java
===================================================================
--- FeatureTypeAttributePanelView.java	(revision 44148)
+++ FeatureTypeAttributePanelView.java	(revision 44149)
@@ -35,6 +35,9 @@
    JTextField txtDefaultValue = new JTextField();
    JLabel lblDataProfile = new JLabel();
    JComboBox cboDataProfile = new JComboBox();
+   JCheckBox chkVirtualField = new JCheckBox();
+   JButton btnVirtualField = new JButton();
+   JTextField txtVirtualField = new JTextField();
    JLabel lblGeometryType = new JLabel();
    JLabel lblGeometrySubtype = new JLabel();
    JLabel lblCRS = new JLabel();
@@ -51,9 +54,6 @@
    JButton btnIntervalStart = new JButton();
    JButton btnIntervalEnd = new JButton();
    JTextField txtIntervalEnd = new JTextField();
-   JCheckBox chkVirtualField = new JCheckBox();
-   JButton btnVirtualField = new JButton();
-   JTextField txtVirtualField = new JTextField();
    JLabel lblIsPrimaryKey = new JLabel();
    JCheckBox chkIsPrimaryKey = new JCheckBox();
    JLabel lblIsAutomatic = new JLabel();
@@ -151,7 +151,7 @@
    public JPanel createPanel()
    {
       JPanel jpanel1 = new JPanel();
-      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,FILL:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
+      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,FILL:DEFAULT:NONE,CENTER:2DLU:NONE");
       CellConstraints cc = new CellConstraints();
       jpanel1.setLayout(formlayout1);
 
@@ -170,26 +170,20 @@
       jpanel1.add(cboFieldType,cc.xy(4,4));
 
       tabAditionalFields.setName("tabAditionalFields");
-      tabAditionalFields.addTab("_Basic_types",null,createPanel1());
-      tabAditionalFields.addTab("_Geometry",null,createPanel2());
-      tabAditionalFields.addTab("_Time",null,createPanel4());
+      tabAditionalFields.addTab("_Basic_fields",null,createPanel1());
+      tabAditionalFields.addTab("_Geometry",null,createPanel3());
+      tabAditionalFields.addTab("_Time",null,createPanel5());
       jpanel1.add(tabAditionalFields,cc.xywh(2,8,3,1));
 
-      chkVirtualField.setActionCommand("Campo virtual");
-      chkVirtualField.setName("chkVirtualField");
-      chkVirtualField.setText("_Virtual_field");
-      jpanel1.add(chkVirtualField,cc.xy(2,10));
-
-      jpanel1.add(createPanel6(),cc.xy(4,10));
       jpanel1.add(createPanel7(),cc.xy(4,6));
-      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7,8,9,10,11 });
+      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7,8,9 });
       return jpanel1;
    }
 
    public JPanel createPanel1()
    {
       JPanel jpanel1 = new JPanel();
-      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE");
+      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE");
       CellConstraints cc = new CellConstraints();
       jpanel1.setLayout(formlayout1);
 
@@ -221,13 +215,40 @@
       cboDataProfile.setName("cboDataProfile");
       jpanel1.add(cboDataProfile,cc.xy(4,8));
 
-      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7,8 });
+      chkVirtualField.setActionCommand("Campo virtual");
+      chkVirtualField.setName("chkVirtualField");
+      chkVirtualField.setText("_Virtual_field");
+      jpanel1.add(chkVirtualField,cc.xy(2,10));
+
+      jpanel1.add(createPanel2(),cc.xy(4,10));
+      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7,8,9,10 });
       return jpanel1;
    }
 
    public JPanel createPanel2()
    {
       JPanel jpanel1 = new JPanel();
+      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
+      CellConstraints cc = new CellConstraints();
+      jpanel1.setLayout(formlayout1);
+
+      btnVirtualField.setActionCommand("...");
+      btnVirtualField.setName("btnVirtualField");
+      btnVirtualField.setText("...");
+      EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
+      btnVirtualField.setBorder(emptyborder1);
+      jpanel1.add(btnVirtualField,cc.xy(3,1));
+
+      txtVirtualField.setName("txtVirtualField");
+      jpanel1.add(txtVirtualField,cc.xy(1,1));
+
+      addFillComponents(jpanel1,new int[]{ 2 },new int[0]);
+      return jpanel1;
+   }
+
+   public JPanel createPanel3()
+   {
+      JPanel jpanel1 = new JPanel();
       FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
       CellConstraints cc = new CellConstraints();
       jpanel1.setLayout(formlayout1);
@@ -250,12 +271,12 @@
       cboGeometrySubtype.setName("cboGeometrySubtype");
       jpanel1.add(cboGeometrySubtype,cc.xy(4,4));
 
-      jpanel1.add(createPanel3(),cc.xy(4,6));
+      jpanel1.add(createPanel4(),cc.xy(4,6));
       addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7 });
       return jpanel1;
    }
 
-   public JPanel createPanel3()
+   public JPanel createPanel4()
    {
       JPanel jpanel1 = new JPanel();
       FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
@@ -276,7 +297,7 @@
       return jpanel1;
    }
 
-   public JPanel createPanel4()
+   public JPanel createPanel5()
    {
       JPanel jpanel1 = new JPanel();
       FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE");
@@ -296,12 +317,12 @@
       lblInterval.setText("_Interval");
       jpanel1.add(lblInterval,new CellConstraints(2,5,1,1,CellConstraints.DEFAULT,CellConstraints.TOP));
 
-      jpanel1.add(createPanel5(),cc.xy(4,5));
+      jpanel1.add(createPanel6(),cc.xy(4,5));
       addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6 });
       return jpanel1;
    }
 
-   public JPanel createPanel5()
+   public JPanel createPanel6()
    {
       JPanel jpanel1 = new JPanel();
       FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE");
@@ -340,27 +361,6 @@
       return jpanel1;
    }
 
-   public JPanel createPanel6()
-   {
-      JPanel jpanel1 = new JPanel();
-      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
-      CellConstraints cc = new CellConstraints();
-      jpanel1.setLayout(formlayout1);
-
-      btnVirtualField.setActionCommand("...");
-      btnVirtualField.setName("btnVirtualField");
-      btnVirtualField.setText("...");
-      EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
-      btnVirtualField.setBorder(emptyborder1);
-      jpanel1.add(btnVirtualField,cc.xy(3,1));
-
-      txtVirtualField.setName("txtVirtualField");
-      jpanel1.add(txtVirtualField,cc.xy(1,1));
-
-      addFillComponents(jpanel1,new int[]{ 2 },new int[0]);
-      return jpanel1;
-   }
-
    public JPanel createPanel7()
    {
       JPanel jpanel1 = new JPanel();