Index: H2SpatialHelper.java
===================================================================
--- H2SpatialHelper.java	(revision 44197)
+++ H2SpatialHelper.java	(revision 44198)
@@ -27,7 +27,7 @@
 import org.apache.commons.dbcp.BasicDataSource;
 import org.apache.commons.io.FilenameUtils;
 import org.apache.commons.lang3.StringUtils;
-import org.gvsig.fmap.dal.SQLBuilder;
+import org.gvsig.expressionevaluator.ExpressionBuilder.GeometrySupportType;
 import org.gvsig.fmap.dal.exception.InitializeException;
 import org.gvsig.fmap.dal.resource.exception.AccessResourceException;
 import org.gvsig.fmap.dal.spi.DataServerExplorerProviderServices;
@@ -48,11 +48,12 @@
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
+@SuppressWarnings("UseSpecificCatch")
 public class H2SpatialHelper extends JDBCHelperBase {
 
-    static final Logger logger = LoggerFactory.getLogger(H2SpatialHelper.class);
+    static final Logger LOGGER = LoggerFactory.getLogger(H2SpatialHelper.class);
 
-    public static final String H2SpatialJDBCDriver = "org.h2.Driver";
+    public static final String H2SPATIAL_JDBC_DRIVER = "org.h2.Driver";
     
     public static String getConnectionURL(H2SpatialConnectionParameters params) {
         String connectionURL;
@@ -88,7 +89,7 @@
                 dbfilename
             );
         }
-        logger.debug("connectionURL: {}", connectionURL);
+        LOGGER.debug("connectionURL: {}", connectionURL);
         return connectionURL;
     }
 
@@ -115,11 +116,11 @@
                     Server theServer = Server.createTcpServer("-tcpPort", port, /*"-tcpAllowOthers",*/ "-ifExists");
                     theServer.start();
                     server = theServer;
-                    logger.info("H2 Server started" );
-                    logger.info("  port  :"+ server.getPort());
-                    logger.info("  status:"+ server.getStatus());
+                    LOGGER.info("H2 Server started" );
+                    LOGGER.info("  port  :"+ server.getPort());
+                    LOGGER.info("  status:"+ server.getStatus());
                 } catch (SQLException ex) {
-                    logger.warn("H2 Server not started",ex);
+                    LOGGER.warn("H2 Server not started",ex);
                 }
                 // Tanto si consigue lanzar el server como si no, no lo vuelve a intentar
                 startServer = false;
@@ -192,61 +193,6 @@
 
     }
 
-//    private static class ConnectionProvider {
-//
-//        private static boolean needRegisterDriver = true;
-//
-//
-//        private final H2SpatialConnectionParameters connectionParameters;
-//
-//        public ConnectionProvider(H2SpatialConnectionParameters connectionParameters) {
-//            this.connectionParameters = connectionParameters;
-//        }
-//
-//        public Connection getConnection() throws SQLException {
-//            if (!this.isRegistered()) {
-//                this.registerDriver();
-//            }
-//            Connection conn;
-//            if( !StringUtils.isEmpty(connectionParameters.getUser()) ) {
-//                conn = DriverManager.getConnection(
-//                    connectionParameters.getUrl(),
-//                    connectionParameters.getUser(),
-//                    connectionParameters.getPassword()
-//                );
-//            } else {
-//                conn = DriverManager.getConnection(connectionParameters.getUrl());
-//            }
-//            try {
-//                conn.createStatement().execute("SELECT TOP 1 SRID FROM SPATIAL_REF_SYS");
-//            } catch(SQLException ex) {
-//                H2GISExtension.load(conn);
-//            }
-//            return conn;
-//        }
-//
-//        private boolean isRegistered() {
-//            return needRegisterDriver;
-//        }
-//
-//        public void registerDriver() throws SQLException {
-//            String className = this.connectionParameters.getJDBCDriverClassName();
-//            if (className == null) {
-//                return;
-//            }
-//            try {
-//                Class theClass = Class.forName(className);
-//                if (theClass == null) {
-//                    throw new JDBCDriverClassNotFoundException(H2SpatialLibrary.NAME, className);
-//                }
-//            } catch (Exception e) {
-//                throw new SQLException("Can't register JDBC driver '" + className + "'.", e);
-//            }
-//            needRegisterDriver = false;
-//        }
-//
-//    }
-
     private ConnectionProvider connectionProvider = null;
    
     public H2SpatialHelper(JDBCConnectionParameters connectionParameters) {
@@ -261,8 +207,8 @@
                 this.connectionProvider = new ConnectionProvider(this.getConnectionParameters());
             }
             Connection connection = this.connectionProvider.getConnection();
-            if( logger.isDebugEnabled() ) {
-                logger.debug("getConnection: connection = "+connection.hashCode()+ connectionProvider.toString());
+            if( LOGGER.isDebugEnabled() ) {
+                LOGGER.debug("getConnection: connection = "+connection.hashCode()+ connectionProvider.toString());
             }
             return connection;
         } catch (SQLException ex) {
@@ -272,7 +218,7 @@
 
     @Override
     public void closeConnection(Connection connection) {
-        logger.debug("closeConnection: connection = "+connection.hashCode());
+        LOGGER.debug("closeConnection: connection = "+connection.hashCode());
         super.closeConnection(connection);
     }
     
@@ -310,8 +256,8 @@
     }
 
     @Override
-    public SQLBuilder.GeometrySupportType getGeometrySupportType() {
-        return SQLBuilder.GeometrySupportType.WKB;
+    public GeometrySupportType getGeometrySupportType() {
+        return GeometrySupportType.WKB;
     }
 
     @Override